---
title: XUL improvements in Firefox 3
slug: Mozilla/Firefox/Releases/3/XUL_improvements_in_Firefox_3
tags:
  - Firefox 3
  - XUL
---
<div>{{FirefoxSidebar}}</div><p>{{ Fx_minversion_header(3) }}</p>

<p>Firefox 3 provides a number of new <a href="/en/XUL" title="en/XUL">XUL</a> elements, as well as improvements to existing elements. While this material is documented in detail elsewhere, this article provides a convenient list of these improvements as well as links to the detailed documentation.</p>

<h3 id="New_elements">New elements</h3>

<ul>
 <li><a href="/en/XUL_Tutorial/Numeric_Controls" title="en/XUL_Tutorial/Numeric_Controls">Numeric controls</a>:

  <ul>
   <li>The new <code><a href="/en/XUL/scale" title="en/XUL/scale">&lt;scale&gt;</a></code> element lets you create sliding scales that let the user select any value in a specified range. This widget would typically be used, for example, to create a volume control.</li>
   <li>A new value, <code>number</code>, for the <code>type</code> attribute of textboxes creates a textbox in which only numbers may be entered. In addition, arrow buttons appear to one side which may be used to step through values. {{ interwiki('wikimo', 'XUL:Specs:NumberBox', 'More information about numeric textboxes') }} ({{ Bug(345510) }})</li>
   <li>A <code><a href="/en/XUL/spinbuttons" title="en/XUL/spinbuttons">&lt;spinbuttons&gt;</a></code> element is added which can be used when creating widgets using XBL bindings. ({{ Bug(155053) }})</li>
   <li>Two widgets, <code><a href="/en/XUL/datepicker" title="en/XUL/datepicker">&lt;datepicker&gt;</a></code> and <code><a href="/en/XUL/timepicker" title="en/XUL/timepicker">&lt;timepicker&gt;</a></code>, can be used to allow the entry of dates and times. The datepicker is available in a number of styles by setting the <code>type</code> attribute, to allow entry with textboxes or a calendar grid. {{ interwiki('wikimo', 'XUL:Specs:DateTimePickers', 'More information about date pickers') }} <a href="/en/XUL/datepicker" title="en/XUL/datepicker">Datepicker Reference</a> <a href="/en/XUL/timepicker" title="en/XUL/timepicker">Timepicker Reference</a></li>
  </ul>
 </li>
 <li>A guide has been created for <a href="/en/XUL/PopupGuide" title="en/XUL/PopupGuide">menus and popups</a> describing new features available:
  <ul>
   <li>A <code><a href="/en/XUL/dropmarker" title="en/XUL/dropmarker">&lt;dropmarker&gt;</a></code> element is added which is useful when creating menu-like widgets using XBL bindings. ({{ Bug(348614) }})</li>
   <li>The <code><a href="/en/XUL/panel" title="en/XUL/panel">&lt;panel&gt;</a></code> element is new and designed for popups that are not menus. They can support any type of content. The &lt;menupopup&gt; element should be used for menus. Menus provide keyboard navigation and support opening and closing submenus.</li>
  </ul>
 </li>
</ul>

<h3 id="Improvements_to_trees">Improvements to trees</h3>

<ul>
 <li>Trees can now be scrolled horizontally. If the columns don't fit into the available width, a horizontal scrollbar appears. This happens if the columns' specified widths add up to more than the available space. See {{ Bug(212789) }} for details.</li>
 <li>A new selection style allows cells to be selected individually, instead of entire rows. To use this selection style, set the tree's <code>seltype</code> attribute to <code>cell</code>.</li>
 <li>Trees now support editing of individual cells. When the user double-clicks an editable cell, a text field appears in which the user can edit the contents of the cell. See {{ interwiki('wikimo', 'XUL:Tree', 'these notes') }} for details.</li>
 <li>&lt;treecol&gt; elements now support an <code>overflow</code> attribute which may be set to true to allow the text of cells within that column to expand to neighbouring blank cells if the text is too large to fit into that single cell.</li>
</ul>

<h3 id="Improvements_to_menus">Improvements to menus</h3>

<ul>
 <li>The <code>image</code> attribute is now used consistently for setting images.</li>
 <li>Menulists fire the <code>select</code> event when selecting an item.</li>
 <li>The <code>inputField</code> and <code>editable</code> properties have been added to menulist</li>
 <li>The <code>&lt;menu&gt;</code>, <code>&lt;menuitem&gt;</code> and <code>&lt;menuseparator&gt;</code> elements now have a readonly <code>selected</code> property which retrieves whether the item is selected in a &lt;menulist&gt;</li>
 <li>The <code>&lt;menu&gt;</code>, <code>&lt;menuitem&gt;</code> and <code>&lt;menuseparator&gt;</code> elements now have a readonly <code>control</code> property which returns the enclosing &lt;menulist&gt;</li>
 <li>The <code>&lt;menu&gt;</code>, <code>&lt;menuitem&gt;</code> and <code>&lt;menuseparator&gt;</code> elements now support the <code>accessKey</code>, <code>disabled</code>, <code>crop</code>, <code>image</code> and <code>label</code> properties which set the corresponding attribute</li>
 <li>The &lt;menu&gt; element now has methods to append, insert and remove menuitems. ({{ Bug(372552) }})</li>
 <li>Editable menulists now offer an <code>editor</code> property to get the internal {{ Interface("nsIEditor") }} for its text field.</li>
 <li>Menus may now be made translucent on platforms that support it ({{ Bug(70798) }}).</li>
</ul>

<h3 id="Improvements_to_textboxes">Improvements to textboxes</h3>

<ul>
 <li>Setting a <a href="/en/XUL/textbox" title="en/XUL/textbox">textbox</a>'s <code>spellcheck</code> attribute to <code>true</code> enables inline spellchecking for that textbox.</li>
 <li>The <code>&lt;textbox&gt;</code> now has a <code>reset()</code> method to reset the value of the textbox to the default value. The <code>defaultValue</code> property may be used to retrieve and modify the default value of the textbox.</li>
 <li>An <code>editor</code> property is now offered, which lets you get the internal {{ Interface("nsIEditor") }} for the text field.</li>
 <li><code><a href="/en/XUL/textbox" title="en/XUL/textbox">textbox</a></code> now supports a <code>newlines</code> attribute which specifies how line breaks in pasted text are handled. Possible values are:
  <ul>
   <li><code>pasteintact</code> - paste everything as is</li>
   <li><code>pastetofirst</code> - (default value) paste only up to the first line break</li>
   <li><code>replacewithspaces</code> - replace line breaks with spaces</li>
   <li><code>replacewithcommas</code> - replace line breaks with commas</li>
   <li><code>strip</code> - strip out all line breaks</li>
   <li><code>stripsurroundingwhitespace</code> - strip out all line breaks and surrounding whitespace</li>
  </ul>
 </li>
</ul>

<h3 id="Other_improvements">Other improvements</h3>

<ul>
 <li>The <code>type</code> attribute on a <code>&lt;button&gt;</code> may be set to <code>repeat</code> to create buttons which fire their command event repeatedly while the mouse button is held down.</li>
 <li>The <code><a href="/en/XUL/Attribute/buttondisabledaccept" title="en/XUL/Attribute/buttondisabledaccept">buttondisabledaccept</a></code> attribute can now be used on the <code>&lt;dialog&gt;</code> element to have the accept (OK) button initially disabled.</li>
 <li>The <code>&lt;titlebar&gt;</code> element now supports the <code>allowevents</code> attribute to allow events to be passed to the children of the titlebar.</li>
 <li>The <code>&lt;splitter&gt;</code> now supports an additional value for the <code>collapse</code> attribute of <code>'both'</code> which indicates that the splitter can collapse elements on both sides of it when dragged. The <code>substate</code> attribute will set to either before or after when one is collapsed. ({{ Bug(337955) }})</li>
 <li>The <code>&lt;richlistbox&gt;</code> element now supports multiple selection. Set the <code>seltype</code> attribute to <code>'multiple'</code> to enable this.</li>
 <li>The <code>&lt;radio&gt;</code> element has a <code>group</code> attribute which may be set to the id of a <code>&lt;radiogroup&gt;</code> element which the radio button belongs to. This allows the radio buttons to arranged in a manner that may not be as suitable when placing them all inside a radiogroup.</li>
 <li>Menus, panels and tooltips support two additional methods, <code><a href="/en/XUL/Method/openPopup" title="en/XUL/Method/openPopup">openPopup()</a></code> and <code><a href="/en/XUL/Method/openPopupAtScreen" title="en/XUL/Method/openPopupAtScreen">openPopupAtScreen()</a></code>. These methods should be used instead of <code>showPopup()</code> which was found to be confusing to use.</li>
 <li>Handling of the <code>&lt;key&gt;</code> element improved for non-Latin keyboard layout users. See <a href="/en/Gecko_Keypress_Event" title="en/Gecko_Keypress_Event">Gecko Keypress Event</a>.</li>
 <li>On Mac OS X, the <a href="/en/XUL/Attribute/activetitlebarcolor" title="en/XUL/Attribute/activetitlebarcolor">activetitlebarcolor</a> and <a href="/en/XUL/Attribute/inactivetitlebarcolor" title="en/XUL/Attribute/inactivetitlebarcolor">inactivetitlebarcolor</a> attributes of the root elements (<code>&lt;window&gt;</code>, <code>&lt;dialog&gt;</code>, <code>&lt;prefwindow&gt;</code> and <code>&lt;wizard&gt;</code>) are available to customize the color of the windows' title bars.</li>
</ul>

<h3 id="See_also">See also</h3>

<ul>
 <li><a href="/en/XUL" title="en/XUL">XUL</a></li>
 <li><a href="/en/Firefox_3_for_developers" title="en/Firefox_3_for_developers">Firefox 3 for developers</a></li>
</ul>
